#include <ctype.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int optA;
int optS;
int optH;
char *outfile;

void mygetopt(int argc, char *argv[])
{
	while(--argc >= 0) {
		char *s = *++argv;
		if (*s == '-' || *s == '/') {
			switch(toupper(s[1])) {
				case 'S':
					optS = 1;
					break;
				case 'A':
					optA = 1;
					break;
				case '?':
				case 'H':
					optH = 1;
					break;
			}
		}
		else {
			if (!outfile) outfile = s;
		}
	}
}

int main(int argc, char *argv[])
{
	int rc = -1;
	union REGS r;
	struct SREGS sr;
	unsigned iosys_len;
	unsigned blk_seg, blk_len;
	
	mygetopt(argc, argv);
	
	if (optH || !outfile) {
		fprintf(stderr, "usage: iosnap [/a] [/s] output_filename\n");
		return rc;
	}
	
	/* assume IO.SYS area as 0060:0000...DOSdataseg:0000 */
	r.h.ah = 0x52;
	intdosx(&r, &r, &sr);
	iosys_len = (sr.es - 0x60) * 16U;

	if (optA) {
		/* BIOS memory block + IO.SYS */
		blk_seg = 0x40;
		blk_len = 0x200 + iosys_len;
	}
	else if (optS) {
		/* BIOS memory block 0000:0400...0000:05FF */
		blk_seg = 0x40;
		blk_len = 0x0200;
	}
	else {
		/* IO.SYS */
		blk_seg = 0x60;
		blk_len = iosys_len;
	}
	
	r.h.ah = 0x3c;			/* creat */
	r.x.cx = 0;
	r.x.dx = FP_OFF(outfile); sr.ds = FP_SEG(outfile);
	intdosx(&r, &r, &sr);
	if (!r.x.cflag) {
		unsigned h = r.x.ax;
		r.h.ah = 0x40;		/* write */
		r.x.bx = h;
		r.x.cx = blk_len;
		r.x.dx = 0; sr.ds = blk_seg;
		intdosx(&r, &r, &sr);
		if (!r.x.cflag) rc = 0;
		r.h.ah = 0x3e;		/* close */
		r.x.bx = h;
		intdos(&r, &r);
	}
	
	return rc;
}
